function checkSiteName(siteName) {
    var regex = /^[A-Za-z0-9_\-\.\*]+(\:\d{1,5}){0,1}$/; 
    return regex.test(siteName);
}

function listContainsSite(site) {
    var siteList = document.getElementById("sitelist");
    var numRows = siteList.getRowCount();
    var i;
    for(i = 0; i < numRows; i++) {
        if(siteList.getItemAtIndex(i).label == site)
            return true;
    }
    return false;
}

function addSite() {
    var textbox = document.getElementById("siteTextbox");
    var siteName = textbox.value;

    if(siteName.length == 0)
        return false;

    if(! checkSiteName(siteName)) {
        var msg = flashblockBundle.getString("invalidCharsInSiteName");
        alert(msg);
        return false;
    }

    var siteList = document.getElementById("sitelist");
    if(! listContainsSite(siteName))
        //use ensureElementIsVisible due to mozilla bug id 250123
        siteList.ensureElementIsVisible(siteList.appendItem(siteName, ""));
    textbox.value = "";
    siteInput(textbox);
    textbox.focus();
    return true;
}

function removeSite() {
    var siteList = document.getElementById("sitelist");
    var index = siteList.selectedIndex;
    if(index != -1) {
        siteList.removeItemAt(index);
        document.getElementById("btnRemove").disabled = true;
    }
}

function removeAllSites() {
    var siteList = document.getElementById("sitelist");
    var msg = flashblockBundle.getString("confirmClearWhitelist");

    if(confirm(msg)) {
        while(siteList.getRowCount() > 0)
            siteList.removeItemAt(0);
    }
}

function doOK() {
    var prefStr = sitelistToString();
    setWhitelistPref(prefStr);

    setEnabled(document.getElementById("enableCheckbox").checked);

    window.close();
}

function onLoad() {
	flashblockBundle = document.getElementById("bundle_flashblock");
	var isJSDisabled = !isJavascriptEnabled();
	document.getElementById("enableCheckbox").checked = isEnabled();
	var pref = document.getElementById("enableToggleBtn");
	if (pref) {
		pref.checked = isButtonEnabled();
		pref.disabled = isJSDisabled;
	}
	document.getElementById("enableCheckbox").disabled = isJSDisabled;
	document.getElementById("siteTextbox").disabled = isJSDisabled;
	document.getElementById("sitelist").disabled = isJSDisabled;
	document.getElementById("btnRemoveAll").disabled = isJSDisabled;
	popWhitelist();
}

function popWhitelist() {
	var prefStr = getWhitelistPref();
	var i;
	var siteList = document.getElementById("sitelist");
	while(siteList.getRowCount() > 0)
		siteList.removeItemAt(0);

	if(prefStr) {
		var array = prefStr.split(",");
		for (i = 0; i < array.length; i++) {
			siteList.ensureElementIsVisible(siteList.appendItem(array[i]));
		}
	}
}

function doCancel() {
    window.close();
}

function siteInput(siteField) {
	document.getElementById("btnAdd").disabled = !siteField.value;
}

function siteSelected(siteList) {
	document.getElementById("btnRemove").disabled = (siteList.selectedIndex == -1);
}

function sitelistToString() {
    var siteList = document.getElementById("sitelist");
    var numRows = siteList.getRowCount();
    var prefStr = "";
    var i;
    for(i = 0; i < numRows; i++) {
        if(i != 0) prefStr += ",";
        prefStr += siteList.getItemAtIndex(i).label;
    }
    return prefStr;
}

var flashblockBundle;
